# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from radar_msgs/RadarStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class RadarStatus(genpy.Message):
  _md5sum = "5b982da6e1f20a73f7c8a15070ee5a36"
  _type = "radar_msgs/RadarStatus"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header

# Status of the radar

int16       curvature
float32     yaw_rate
float32     vehicle_speed
uint8       max_track_targets
bool        raw_data_mode
int8        temperature
bool        patial_blockage
bool        side_lobe_blockage

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  __slots__ = ['header','curvature','yaw_rate','vehicle_speed','max_track_targets','raw_data_mode','temperature','patial_blockage','side_lobe_blockage']
  _slot_types = ['std_msgs/Header','int16','float32','float32','uint8','bool','int8','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,curvature,yaw_rate,vehicle_speed,max_track_targets,raw_data_mode,temperature,patial_blockage,side_lobe_blockage

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.curvature is None:
        self.curvature = 0
      if self.yaw_rate is None:
        self.yaw_rate = 0.
      if self.vehicle_speed is None:
        self.vehicle_speed = 0.
      if self.max_track_targets is None:
        self.max_track_targets = 0
      if self.raw_data_mode is None:
        self.raw_data_mode = False
      if self.temperature is None:
        self.temperature = 0
      if self.patial_blockage is None:
        self.patial_blockage = False
      if self.side_lobe_blockage is None:
        self.side_lobe_blockage = False
    else:
      self.header = std_msgs.msg.Header()
      self.curvature = 0
      self.yaw_rate = 0.
      self.vehicle_speed = 0.
      self.max_track_targets = 0
      self.raw_data_mode = False
      self.temperature = 0
      self.patial_blockage = False
      self.side_lobe_blockage = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_h2f2Bb2B().pack(_x.curvature, _x.yaw_rate, _x.vehicle_speed, _x.max_track_targets, _x.raw_data_mode, _x.temperature, _x.patial_blockage, _x.side_lobe_blockage))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 15
      (_x.curvature, _x.yaw_rate, _x.vehicle_speed, _x.max_track_targets, _x.raw_data_mode, _x.temperature, _x.patial_blockage, _x.side_lobe_blockage,) = _get_struct_h2f2Bb2B().unpack(str[start:end])
      self.raw_data_mode = bool(self.raw_data_mode)
      self.patial_blockage = bool(self.patial_blockage)
      self.side_lobe_blockage = bool(self.side_lobe_blockage)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_h2f2Bb2B().pack(_x.curvature, _x.yaw_rate, _x.vehicle_speed, _x.max_track_targets, _x.raw_data_mode, _x.temperature, _x.patial_blockage, _x.side_lobe_blockage))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 15
      (_x.curvature, _x.yaw_rate, _x.vehicle_speed, _x.max_track_targets, _x.raw_data_mode, _x.temperature, _x.patial_blockage, _x.side_lobe_blockage,) = _get_struct_h2f2Bb2B().unpack(str[start:end])
      self.raw_data_mode = bool(self.raw_data_mode)
      self.patial_blockage = bool(self.patial_blockage)
      self.side_lobe_blockage = bool(self.side_lobe_blockage)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_h2f2Bb2B = None
def _get_struct_h2f2Bb2B():
    global _struct_h2f2Bb2B
    if _struct_h2f2Bb2B is None:
        _struct_h2f2Bb2B = struct.Struct("<h2f2Bb2B")
    return _struct_h2f2Bb2B
